.nolist
.include "m328pdef.inc" ; Define device ATmega328P
.list
;
; Soma os nmeros de 1 a [R16] e salva o resultado na
; posicao 0x100 da memoria de dados (SRAM).
; Exemplo de desvio condicional e uso de labels.

;		Mneumonico			Comentario					Opcode					
.ORG 0					; Proxima instruo no endereo 0
        CLR R0			; R0: somas parciais			Rd <- 0			0010 01dd dddd dddd 
		MOV R1, R0		; R1: parcelas da soma			Rd <- Rr		0010 01rd dddd rrrr
		LDI R16, 3		; R16: nmero de parcelas		Rd <- K			1110 KKKK dddd KKKK

LABEL:	INC R1			; incrementa R1					Rd <- Rd+1		1001 010d dddd 0011
		ADD R0, R1		; R0 <- R0 + R1					Rd <- Rd+Rr		0000 11rd dddd rrrr
		CP R1, R16	    ; compara R1 e R16				Rd-Rr			0001 01rd dddd rrrr
        BRNE LABEL		; branch se Z==0 para LABEL		PC <- PC+k+1	1111 01kk kkkk k001

		STS 0x100, R0	; DATA(0x100) <- R0				(k) <- Rr		1001 001d dddd 0000 / kkkk kkkk kkkk kkkk
        SLEEP			; modo sleep					SLEEP			1001 0101 1000 1000
