.nolist
.include "m328pdef.inc" ; Define device ATmega328P
.list
; Exemplo para observar no simulador o funcionamento de algumas instrucoes
; simples do processador

.ORG 0x00           ; Define o endereo da prxima instruo

					;	Desc.									Opcode				Cks Wds Flags
; operando implcito
	SEZ				; set flag Z							1001 0100 0001 1000		1	1   Z
	
; direct one register addressing
	INC R0			; Rd <- Rd + 1, d=0..31					1001 010d dddd 0011		1	1	nenhum

; direct two register addressing
	MOV R1, R0		; Rd <- Rr, d=1..31 (r:1..31)			0010 11rd dddd rrrr		1	1	S V N Z

; direct two register addressing
    ADD R0, R1      ; R0 <- R0 + R1 (d:1..31, r=1..31)		0000 11rd dddd rrrr		1	1	H S V N Z C

; valor imediato
	LDI R16, 0xf3	; Rd <- k, d:16..31, k:0..255			1110 KKKK dddd KKKK		1	1	nenhum


; direct data addressing (instruo de 2*16 bits)
	STS 0x100, R16	; DATA(KK) <- Rd (KK:16 bits, r:0..31)	1001 001d dddd 0000		1	2	nenhum

; Direct program adressing
	JMP 0000		; PC <- kkk, kkk:0..4M					1001 010k kkkk 110k		1	2	nenhum

	BREAK


